import java.util.Scanner;

public class Main {

	public static void main(String[] args) {
		Scanner s  = new Scanner(System.in);
		int N = s.nextInt();
		int brVeza = (N * (N-3))/2 + N;
		int [] x = new int[N];
		int [] y = new int[N];
		double [][] duzineStr = new double[N][N];
		int brPrepisivaca = 0;
		if(N<4) {
			brPrepisivaca = 0;
		}else {
			for(int i = 0;i<N;i++) {
				x[i] = s.nextInt();
				y[i] = s.nextInt();
			}
			for(int i = 0;i<N;i++) {
				for(int j = 0;j<N;j++) {
				    duzineStr[i][j] = Math.sqrt((y[j] - y[i]) * (y[j] - y[i]) + (x[i] - x[j]) * (x[i] - x[j]));
					System.out.print(Math.sqrt((y[j] - y[i]) * (y[j] - y[i]) + (x[i] - x[j]) * (x[i] - x[j])) + " ");
				}
				System.out.println("\n");
			}
			for(int i = 0;i<N;i++) {
				for(int j = 0;j<N;j++) {
				    
				    for(int z= 0;z<N;z++) {
				        for(int m = 0;m<N;m++) {
				            if(duzineStr[i][j]>0 && duzineStr[z][m]>0){
				                if(duzineStr[i][j] / 2 == duzineStr[z][m] ){
				                    brPrepisivaca++;
				                }
				            }
				        }
				        
				    }
				}
			    
			}
			
		}
		System.out.println(brPrepisivaca / N);
		
	}

}